#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Utsuho Nonspell 2"]
#text["Utsuho Nonspell 2"]
#Background["./../../../../Stage/RandomBG.txt"]
#System["./../../../../../ds_system/S_System.txt"]

#include"./../../../../../ds_system/Function_Effect.dnh"
#include"./../../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss1.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(40-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimation_UtsuhoA1(Enemy);
	SetInvincibility(Enemy, 100, 77, 55);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(40);
	yield;
	loop(30){yield;}
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2,GetStgFrameHeight/1.5-32,13, 3);
		if(!Hold(60)){break;}
		
		
		ConcentrationA1(Enemy,"CHERRY",90,3,110,[255,255,0]);
		PlaySoundO2(se_ch02, 65);
		if(!Hold(45)){break;}
		ObjAnim_SetAttackA1(Enemy, true);
		if(!Hold(50)){break;}
		
		
		
		let argi = round(round(20-argument/7)/2);
		
		let argr = floor(argument/8);
		let argc = 2+round(argument/16);
		
		let argm = 3+round(argument/3);
		let args = 0.2+argument/32;
		
		let argy = round(round(10-argument/20)/2);
		
		let spdm = argument/60;
		
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			// UtsuhoNonFountain;
			let dir = rand(0,360);
			loop(argi){
				loop(argc){
					loop(argr){
						let a = CreateObjShotB2(EnemyX,EnemyY,3*cos(dir),-9-(0.5*sin(dir)),0,0.15,0,12*spdm,163,10);
						ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
						harden(a,85);
						dir+=360/argr;
					}
					if(!Hold(argy)){break;}
				}
				dir+= 15+rand(0,30);
				PlaySoundO2(se_tan00, 40);
			}
			if(!Hold(1)){break;}
			
			let bang = GetAngleToPlayer(Enemy);
			PlaySoundO2(se_tan01, 40);
			ascent(i in 0..argm){
				let a = CreateObjShotA1(EnemyX-2,EnemyY-30,args,bang+360/argm*i,83,25);
				ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
			}
			if(!Hold(1)){break;}
		}
		task harden(a,w){
			if(!Hold(w)){return;}
			ObjRender_SetBlendType(a,BLEND_ALPHA);
		}
		
		task FireColumn(dir){
		
		}
	}
}

task UtsuhoNonFountain{
	let dir = rand(0,360);
	loop(40){
		loop(5){
			loop(8){
				let a = CreateObjShotB2(EnemyX,EnemyY-30,3*cos(dir),-9-(0.5*sin(dir)),0,0.15,0,12,163,10);
				ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
				harden(a,85);
				dir+=360/8;
			}
		if(!Hold(3)){return;}
		}
	dir+= 15+rand(0,30);
	PlaySoundO2(se_tan00, 40);
	}
	task harden(a,w){
		if(!Hold(w)){return;}
		ObjRender_SetBlendType(a,BLEND_ALPHA);
	}
}

