#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Utsuho Spell 2"]
#Background["./../../../../Stage/RandomBG.txt"]
#System["./../../../../../ds_system/S_System.txt"]

#include"./../../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss1.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;


@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(63-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimation_UtsuhoA1(Enemy);
	SetInvincibility(Enemy, 180, 65/5, 35/5);
	PlayEnemyHitSound(Enemy, 1);
	SetUpNukeRenders;
	BossActions;
}

let IsIntangible = false;
@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		if(!IsIntangible){
			ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
			ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		}
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}


task BossActions{
	
	SetAttackTimer(63);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
	
		
		let face = GetCurrentScriptDirectory~"face/";
		
		ObjCutin_SetSpellcardM4("\"Invisible Sunspot\"", 3500000, "BYAKUREN", face~"spell_use_cut.png", 96, 144, 255);
		
		PlaySoundO1(spell_0);
		
		yield;
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 7, 6);
		ObjEnemyBossScene_StartSpell(objScene);
		
		
		WarningRender = InitRender(WarningRender, 0.7, current~"warning_00.png");
		ObjSpriteList2D_SetSourceRect(WarningRender, 0, 0, 50, 51);
		ObjSpriteList2D_SetDestCenter(WarningRender);
		ObjRender_SetColor(WarningRender, 255, 128, 48);
		ObjRender_SetAlpha(WarningRender, 255);
		
		
		let espd = 1.2+argument/52;
		let aspd = 3.6;
		
		Hold(25);
		let dir = rand(0,360);
		
		let ox = EnemyX;
		let oy = EnemyY;
		let test = 0;
		
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			ConcentrationA1(Enemy,"CHERRY",70,3,100,[255,255,0]);
			PlaySoundB1("se_ch02", 65);
			if(!Hold(25)){break;}
			ObjAnim_SetAttackA1(Enemy, true);
			if(!Hold(15)){break;}
			NukeDrop;
			if(!Hold(1400)){break;}
			IsIntangible = false;
			ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 40, 10);
			if(!Hold(50)){break;}
		}
	}
}

task NukeDrop{
	let sc = 0.1;
	PlaySoundO2(se_tan01, 40);
	let a = CreateLargeNukeA1(EnemyX, EnemyY-30);
	Obj_SetValue(a, "NukeScale", sc);
	Obj_SetValue(a, "NukeHitbox", false);
	ObjMove_SetSpeed(a,1.8);
	ObjMove_SetAngle(a,270);
	if(!Hold(120)){return;}
	PlaySoundO2(se_enep02, 40);
	ObjMove_SetAcceleration(a,-0.02);
	ObjMove_SetMaxSpeed(a,-0.5);
	if(!Hold(20)){return;}
	loop(15){
		Obj_SetValue(a, "NukeScale", sc);
		sc+=2.9/15;
		if(!Hold(1)){break;}
	}
	if(!Hold(20)){return;}
	// ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, -70, 7, 6);
	PelletRadius(a,260);
	if(!Hold(600)){return;}
	ObjAnim_SetAttackA1(Enemy, false);
	if(!Hold(38)){return;}
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, -192, 7, 6);
	if(!Hold(50)){return;}
	IsIntangible = true;
	EyesOfLunacyA1(410, current~"RedEyeRaven.png", 0, 0, 256, 128);
	RingSetUp(a);
	// ascent(i in 0..13){
		// Obj_SetValue(a, "NukeAlpha", 192-24*(i%2));
		// if(!Hold(6)){break;}
	// }
	// ReisenBlurA1(37, 360);
	Obj_SetValue(a, "NukeHitbox", true);
	Obj_SetValue(a, "NukeAlpha", 96);
	if(!Hold(150)){return;}
	ascent(i in 0..2){
		let lmod = 1-2*i;
		// FireGiantLaserWarnA1(GetStgFrameWidth/2+GetStgFrameWidth/1.9*lmod, GetStgFrameHeight+16, 270-65*lmod, 120, 150);
	}
	if(!Hold(100)){return;}
	ascent(i in 0..11){
		Obj_SetValue(a, "NukeAlpha", 96+24*(i%2));
		if(!Hold(8)){break;}
	}
	ascent(i in 0..18){
		Obj_SetValue(a, "NukeAlpha", 96+24*(i%2));
		if(!Hold(4)){break;}
	}
	if(!Hold(1)){return;}
	FireRadius(a,240);
	ObjMove_SetAcceleration(a,-0.03);
	ObjMove_SetMaxSpeed(a,-2.2);
	Obj_SetValue(a, "NukeHitbox", false);
	Obj_SetValue(a, "NukeAlpha", 192);
}

task FireGiantLaserWarnA1(x, y, ang, duration, delay){
	FireWarningPathA1(x, y, 9, ang, delay);
	loop(delay-1){if(!Hold(1)){break;}}
	if(!Hold(1)){return;}
	FireNukeLaserA1(x, y, ang, duration);
}


task PelletRadius(obj,rad){
	let dir = rand(0,360);
	ascent(i in 0..210){
		let X = ObjMove_GetX(obj);
		let Y = ObjMove_GetY(obj);
		loop(7){ 
			let a = CreateObjShotA2(X+rad*cos(dir),Y-rad*sin(dir),5-(i*0.02),-dir,-0.02,1.6,480,10);
			ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
			dir+=360/7;
			
		}
		dir-=rand(6,12);
		PlaySoundO2(se_tan00, 40);
		if(!Hold(3)){return;}
	}
}

task FireRadius(obj,rad){
	if(!Hold(0)){return;}
	let dir = rand(0,360);
	descent(i in 0..6){
		let X = ObjMove_GetX(obj);
		let Y = ObjMove_GetY(obj);
		loop(30){ 
			let a = CreateObjShotA1(X+rad*cos(dir),Y-rad*sin(dir),1,-dir,369,60);
			ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
			dir+=360/30;
			
		}
		PlaySoundO2(se_tan01, 40);
		dir-=rand(6,12);
		if(!Hold(30)){break;}
	}
}

task PelletRadiusInner(obj,dur, rad){
	let argi = 2+round(argument/20);
	let dir = round(8-argument/15)*argi;
	let mdir = 0;
	ascent(i in 0..dur/7){
		let X = ObjMove_GetX(obj);
		let Y = ObjMove_GetY(obj);
		ascent(x in 0..2){
			let lmod = 1-(2*x);
			ascent(i in 0..argi){
				let lang = 270+(mdir+dir*i+rand(-dir/2, dir/2))*lmod;
				let a = CreateObjShotA2(X+rad*cos(lang),Y+rad*sin(lang),5-(i*0.02),180+lang,-0.02,1,480,10);
				ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
			}
		}
		mdir += 180/dur*7;
		if(!Hold(7)){break;}
	}
}

task Barrier{
	let dir = rand(0,360);
	ascent(i in 3..13){
		let rot = rand(-0.3,0.3);
			loop(25){
				let a = CreateObjShotA2(GetStgFrameWidth/2,-10,1+(i*1.5),dir,-0.1-(i*0.03),0.5,32,5);
				ObjMove_SetAngularVelocity(a,rot);
				ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
				ObjShot_SetDeleteFrame(a, 270);
				dir+=360/25;
			}
		dir+=360/25/2;
	}
}

task ring(obj,numb,rad,way){
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	let dir = rand(0,360);
		ascent(i in 0..numb){
			let a = CreateObjShotA1(x+rad*cos(dir),y+rad*sin(dir),0,0,209,0);
			ObjShot_SetAutoDelete(a,false);
			ObjShot_SetSpellResist(a,true);
			rot(a,obj,way,dir);
			dir+=360/numb;
		}
	task rot(obj,obj2,way,dir){
		let x = ObjMove_GetX(obj2);
		let y = ObjMove_GetY(obj2);
		let count = dir;
		loop(410){
			x = ObjMove_GetX(obj2);
			y = ObjMove_GetY(obj2);
			ObjMove_SetX(obj,x+rad*cos(count));
			ObjMove_SetY(obj,y+rad*sin(count));
			count+=way;
			yield;
		}
		Obj_Delete(obj);
	}
}

task RingSetUp(a){
	ring(a,18,200,0.2);
	ring(a,18,180,-0.2);
	ring(a,8,160,0.5);
	ring(a,8,140,-0.5);
	ring(a,9,60,rand(-1,1));
	ring(a,7,40,rand(-1,1));
	ring(a,5,20,rand(-1,1));
}