#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./../../../../Stage/RandomBG.txt"]
#System["./../../../../../ds_system/S_System.txt"]

#include"./../../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss1.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;
let EV_DUPLICATE_ACTIVE_PLAYER_SPRITE	= EV_USER_PLAYER+150;
let EV_TEAM_HAS_SWAPPED					= EV_USER_PLAYER+151;

let Clone = ID_INVALID;
let timeduration = 0;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(2222248-2*(argument/12-4));}
	
	
	case(EV_TEAM_HAS_SWAPPED){
		ResetCloneObject;
	}

}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimation_UtsuhoA1(Enemy);
	SetInvincibility(Enemy, 210, 85, 75);
	PlayEnemyHitSound(Enemy, 1);
	SetUpNukeRenders;
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(424);
	yield;
	loop(30){yield;}
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	Obj_DeleteBoss;
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2,GetStgFrameHeight/3.5,13, 5);
		if(!Hold(45)){break;}
		
		WarningRender = InitRender(WarningRender, 0.7, current~"warning_00.png");
		// ObjRender_SetBlendType(WarningRender, BLEND_INV_DESTRGB);
		// ObjSpriteList2D_SetSourceRect(WarningRender, 32, 0, 64, 32);
		// ObjSpriteList2D_SetDestRect(WarningRender, -32, -32, 32, 32);
		ObjSpriteList2D_SetSourceRect(WarningRender, 0, 0, 50, 51);
		ObjSpriteList2D_SetDestCenter(WarningRender);
		ObjRender_SetColor(WarningRender, 255, 128, 48);
		ObjRender_SetAlpha(WarningRender, 255);
		
		
		// argument = 72;
		
		let argm = ceil(3.3+argument/12);
		let argi = 20+10*argm+argument/2;
		
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){

			ObjAnim_SetAttackA2(Enemy, 75*2+40);
			// FireWarningCircleA1(EnemyX, EnemyY, 4, 16, 164);				
			if(!Hold(40)){break;}
			let obang = GetAngleToPlayer(Enemy)+rand(-5, 5);
			ascent(x in 0..2){
				if(!Hold(30)){break;}
				let mod = 1 - 2*(x%2);
				let bang = obang + 360/argm/2*x;
				let spd = 1.5;
				ascent(i in 0..argm){
					let lang = bang+360/argm*i;
					let a = CreateNukeBulletA1(EnemyX, EnemyY-30, spd, lang, spd*0.4*mod, 1.25+0.25*x, 0.00055, 65);
					ObjMove_SetSpeed(a, 3.5-1*x);
					ObjMove_SetMaxSpeed(a, spd);
					ObjMove_SetAcceleration(a, -(3-spd)/30);
					// ObjMove_SetAngularVelocity(a, spd*0.3*mod);
				}
				if(!Hold(40)){break;}
			}
			
			// if(!Hold(120)){break;}			
			// obang = GetAngleToPlayer(Enemy);
			// FireWarningPathA1(EnemyX, EnemyY, 13, obang, 128);
			// if(!Hold(20)){break;}
			// FireNukeLaserA1(EnemyX-24*cos(obang), EnemyY-24*sin(obang), obang, 200);
			
			if(!Hold(70)){break;}
			// BG_TimeStopL1(false, 0.5, 80, 20, 69);
			TimeSpeed = 0.35+argument/200;
			timeduration = 390;
			TimeStopL1(255, 64, 128, 0, 0.1, timeduration, 20, 69);
			if(!Hold(timeduration)){break;}
			TimeSpeed = 1;
			ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2+rand(-80, 80),GetStgFrameHeight/3.5+rand(-48, 48),13, 5);
			
			if(!Hold(1)){break;}
		}
	}
}




function CreateNukeBulletA1(x, y, spd, ang, angv, tscl, tscld, del){
	let nuke = CreateLargeNukeA1(x, y);
	ObjMove_SetSpeed(nuke,spd);
	ObjMove_SetAngularVelocity(nuke, angv);
	ObjMove_SetAngle(nuke,ang);
	
	
	DoStuff;
	return nuke;


	task DoStuff{
		let HasBeenMiraged = 0;
	
		let localspeed = TimeSpeed;
		let argi = round(3+argument/7);
		ascent(i in 0..del){
			Obj_SetValue(nuke, "NukeScale", tscl/(del-1)*i);
			if(!Hold(1)){break;}
		}
		if(!Hold(8)){break;}
		ObjMove_SetAcceleration(nuke,0);
		
		while(!Obj_IsDeleted(nuke) && tscl > 0.08){
			DoNukeStuff;
			if(HasBeenMiraged < 2){
				ObjMove_SetSpeed(nuke,spd*TimeSpeed);
				ObjMove_SetAngularVelocity(nuke, angv*TimeSpeed);
			}else if(HasBeenMiraged == 2){
				ObjMove_SetSpeed(nuke,spd);
				ObjMove_SetMaxSpeed(nuke, spd*3);
				ObjMove_SetAcceleration(nuke, 0.03);
				ObjMove_SetAngularVelocity(nuke, 0);
				HasBeenMiraged++;
			}
			if(localspeed != TimeSpeed){
				angv *= TimeSpeed;
				if(localspeed > TimeSpeed){
					Obj_SetValue(nuke, "NukeHitbox", true);
					FireRingOfBullets;
				}else{
					Obj_SetValue(nuke, "NukeHitbox", false);
				}
				localspeed = TimeSpeed;
				HasBeenMiraged++;
			}
			if(!Hold(1)){break;}
		}
		
		
		let r = 255;
		let g = 64;
		let b = 42;
		ExplosionA1(nuke, Obj_GetValueD(nuke, "NukeGraphic", "CHERRY"),
				[r, g, b],
				[r, g, b]);
		yield;
		Obj_Delete(nuke);
		
		sub DoNukeStuff{
			x = ObjMove_GetX(nuke);
			y = ObjMove_GetY(nuke);
			ang = ObjMove_GetAngle(nuke);
			tscl-=tscld*TimeSpeed;
			Obj_SetValue(nuke, "NukePulseSpeed", 5*TimeSpeed);
			Obj_SetValue(nuke, "NukeScale", tscl);
		}
		
		task FireRingOfBullets{
			let rlang = ang;
			let bid = [];
			ascent(i in 0..argi){
				let lang = ang+360/argi*i;
				let a = CreateObjShotA1(x+82*tscl*cos(lang), y+82*tscl*sin(lang), 0, ang, 7, 10);
				ObjShot_SetAutoDelete(a, false);
				bid = bid~[a];
				// ObjMove_SetAngularVelocity(a, angv*TimeSpeed);
				ObjShot_SetDeleteFrame(a, timeduration);
			}
			ascent(i in 0..timeduration){
				
				ascent(i in 0..argi){
					let lang = rlang+360/argi*i;
					let a = bid[i];
					ObjMove_SetPosition(a, x+82*tscl*cos(lang), y+82*tscl*sin(lang));
				}
				
				rlang += 0.4;
				if(!Hold(1)){break;}
			}
		}
		
	}
	
}


task switchbox{
	let X = GetPlayerX;
	let Y = GetPlayerY;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		ascent(i in 0..180){
			X = GetPlayerX;
			Y = GetPlayerY;
			SetPositionClamped(Clone, X+90, Y, 0);
			if(!Hold(1)){break;}
		}
		ObjMove_SetPosition(GetPlayerObjectID,X+90,Y);
		ascent(i in 0..180){
			X = GetPlayerX;
			Y = GetPlayerY;
			SetPositionClamped(Clone, X-90, Y, 0);
			if(!Hold(1)){break;}
		}
		ObjMove_SetPosition(GetPlayerObjectID,X-90,Y);
	}
}

let CloneActive = false;
let CloneSwap = false;
task switchbox2{

	let tx=GetPlayerX;
	let reduc = 0;

	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		
		
		if(GetVirtualKeyState(VK_SLOWMOVE) != KEY_FREE){
			reduc += 1;
		}else{
			reduc = max(0, reduc-1);
		}
	
		tx = GetStgFrameWidth-GetPlayerX;
		tx += reduc * tx / absolute(tx);
		
		SetPositionClamped(Clone, tx, GetPlayerY, 0);
		if(!Hold(1)){break;}
	}
}


task SetPositionClamped(obj, x, y, z){
	
	ObjRender_SetPosition(obj, min(max(GetPlayerClip[0], x), GetPlayerClip[2]), min(max(GetPlayerClip[1], y), GetPlayerClip[3]), z);
	
}


task ResetCloneObject{
	// yield;
	yield;
	yield;
	NotifyEvent(GetPlayerScriptID, EV_DUPLICATE_ACTIVE_PLAYER_SPRITE, false);
	yield;
	Obj_Delete(Clone);
	Clone = GetCommonData("MirageCharacter", ID_INVALID);
	Obj_SetRenderPriority(Clone, 0.75);
	
	ObjRender_SetAlpha(Clone, 192);
	ObjRender_SetColor(Clone, 164, 112, 112);
	DoShaderEffect(Clone);
	
	ObjRender_SetPosition(Clone, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
	
	task DoShaderEffect(obj){
		if(quality == 0){return;}
		yield;
		if(!Obj_GetValueD(obj, "DoShaderEffect", true)){return;}
	
		let pathShader = libSrc~"warp_harsh.hlsl";
		ObjShader_SetShaderF(obj, pathShader);
		ObjShader_SetTechnique(obj, "TecMain");
		
		let frame = round(rand(0, 360));
		let mint = 0.01;
		let speed = 2;
		
		ObjShader_SetFloat(obj, "p_int", mint);
		
		
		while(!Obj_IsDeleted(obj)){
			ObjShader_SetFloat(obj, "p_frame", frame);
			frame+=speed;
			yield;
		}
		
	}
}




