#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Utsuho Spell 4"]
#text[""]
#Background["./../../../../Stage/RandomBG.txt"]
#System["./../../../../../ds_system/S_System.txt"]

#include"./../../../../../ds_system/Function_Effect.dnh"
#include"./../../../../../ds_system/SpellFunctions.h"
#include"./Animation.h"
let current = GetCurrentScriptDirectory;

let imgEnemy = current~"boss1.png"; 
let BossCutIn = current~"cutin.png";

let objPlayer = GetPlayerObjectID;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(66-2*(argument/12-4));}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimation_UtsuhoA1(Enemy);
	SetInvincibility(Enemy, 200, 45/5, 15/5);
	PlayEnemyHitSound(Enemy, 1);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 32);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 24);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
	}
	yield;
}

task BossActions{
	SetAttackTimer(66);
	yield;
	PerformActions;
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	// Obj_DeleteBoss;
	ExplosionB2(Enemy,"CHERRY",[192, 192, 192],[192, 192, 192]);
	EnemyDead = true;
	PlaySoundO1(boss_d);
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		let face = GetCurrentScriptDirectory~"face/";
		
		ObjCutin_SetSpellcardM4("\"Lunatic Sunray\"", 3500000, "BYAKUREN", face~"spell_use_cut.png", 96, 144, 255);
		
		PlaySoundO1(spell_0);
		
		yield;
		ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 7, 6);
		ObjEnemyBossScene_StartSpell(objScene);
		
		
		
		if(!Hold(90)){return;}
		
		SetUpNukeRenders;
		
		// FireDebugAngle;
		
		// argument = 120;
		
		let argm = ceil(3+argument/18);
		let argi = 20+10*argm+argument/2;
		let obang = GetAngleToPlayer(Enemy)+rand(-5, 5);
		obang = 90+35;
		
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			ConcentrationA1(Enemy,"CHERRY",90,3,110,[255,255,0]);
			PlaySoundO2(se_ch02, 65);
			ObjMove_SetDestAtWeight(Enemy,GetStgFrameWidth/2,GetStgFrameHeight/4, 8, 5);
			if(!Hold(30)){break;}
			ObjAnim_SetAttackA1(Enemy, true);
			if(!Hold(35)){break;}
			
			// let bang = rand(0, 360);
			// let bang = GetAngleToPlayer(Enemy)-argi;
			
			obang += 25;
			
			// ascent(z in 0..2){
				// let rmod = 1 - 2*z;
				ascent(i in 0..2){
					let mod = 1 - 2*i;
					// mod *= rmod;
					let bang = obang + 360/argm/2*i;
					ascent(i in 0..argm){
						// let lang = bang + argi*2/(argm-1)*i;
						let lang = bang+360/argm*i;
						FireNukeFountainA1(EnemyX, EnemyY, 0.5, lang, 2-argument/200, mod);
						// bang += 360/argm;
						// if(!Hold(30-argument/8)){break;}	
					}
					if(!Hold(150)){break;}	
				}
				if(!Hold(70)){break;}
			// }
		}
	}
}


task FireNukeFountainA1(x, y, spd, ang, angdev, mod){
	let nuke = CreateLargeNukeA1(x, y);
	ObjMove_SetSpeed(nuke, 0);
	ObjMove_SetAngle(nuke, ang);
	ObjMove_SetMaxSpeed(nuke, spd);
	ObjMove_SetAcceleration(nuke, spd/70);
	ObjMove_SetAngularVelocity(nuke, spd*0.3*mod);
	
	ObjMove_AddPatternA2(nuke, 500, NO_CHANGE, NO_CHANGE, 0, 0, spd);
	
	
	let xm = cos(ang);
	let ym = sin(ang);
	
	
	
	
	let tscl = 1;
	let rscl = tscl;
	ascent(i in 0..25){
		Obj_SetValue(nuke, "NukeScale", tscl/24*i);
		if(!Hold(1)){break;}
	}
	
	
	let nbspd = 1.2+argument/44;
	
	let txa = 0.1*xm;
	let tya = 0.1*ym;
	let txm = nbspd*xm;
	// let tym = 6*ym;
	let tym = absolute((nbspd-1)*ym) + 1;
	
	tym = tym*argument/70;
	
	let nscr = 0.032;
	
	let btype = 353;
	let bspdm = 1;
	
	
	let bcoly = 6-floor(argument/58);
	let bcoldely = 65-round(argument/4);
	
	let difc = bcoly + bcoldely;
	
	if(!Hold(65-argument/2)){return;}
	
	
	while(!Obj_IsDeleted(nuke) && tscl > 0.05){
		x = ObjMove_GetX(nuke);
		y = ObjMove_GetY(nuke);
		ang = ObjMove_GetAngle(nuke);
		xm = cos(ang%180);
		ym = sin(ang%180);
		
		txa = 0.1*xm;
		tya = 0.1*ym;
		txm = nbspd*xm;
		tym = absolute((nbspd-1)*ym) + 1;
		
		let ntx = -4*xm+rand(-angdev, angdev);
		let nty = -4*ym+rand(-angdev, angdev);
		ascent(i in 0..4){
			// let a = CreateObjShotB2(EnemyX,EnemyY-30,3*cos(dir),-9-(0.5*sin(dir)),0,0.15,0,12,163,10);
			
			
			if(GetDistance(x, y, GetPlayerX, GetPlayerY) > tscl*224){
				let a = CreateObjShotB2(x, y, ntx, nty, txa, tya, txm*bspdm, tym*bspdm, btype, 10);
			}
			// if(tscl > 0.8){
				// let a = CreateObjShotB2(x, y, ntx, nty, txa, tya, txm, tym, 169, 10);
			// }else if(tscl > 0.45){
				// let a = CreateObjShotB2(x, y, ntx, nty, txa, tya, txm, tym, 10, 10);
			// }else if(tscl > 0.05){
				// let a = CreateObjShotB2(x, y, ntx, nty, txa, tya, txm, tym, 353, 10);
			// }
			// ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
			
			// ObjMove_AddPatternB3(a, 50, NO_CHANGE, NO_CHANGE, txa, tya, txm, tym, 5091);
			
			// if(!Hold(6)){break;}
			loop(bcoly){
				tscl -= nscr/difc;
				Obj_SetValue(nuke, "NukeScale", tscl);
				if(!Hold(1)){break;}
				if(tscl < 0.15){
					Obj_SetValue(nuke, "NukeHitbox", true);
				}
			}
		}
		// if(tscl > 0.8){
			// btype = 169;
		// }else if(tscl > 0.45){
			// bspdm = 0.75;
			// btype = 10;
		// }else if(tscl > 0.05){
			// bspdm = 0.35;
			// btype = 353;
		// }
		loop(bcoldely){
			tscl -= nscr/difc;
			Obj_SetValue(nuke, "NukeScale", tscl);
			if(!Hold(1)){break;}
		}
		if(!Hold(1)){break;}
	}
	let r = 255;
	let g = 64;
	let b = 42;
	ExplosionA1(nuke, Obj_GetValueD(nuke, "NukeGraphic", "CHERRY"),
			[r, g, b],
			[r, g, b]);
	yield;
	Obj_Delete(nuke);
}


task FireDebugAngle{
	let lx = GetPlayerX;
	let ly = GetPlayerY;
	let xm = 0;
	let ym = 1;
	
	let xml = 0;
	let yml = 1;
	
	let xmr = 0;
	let ymr = 1;
	
	let angdev = 25;
	
	
	let ang = 270;
	while(true){
		let x = GetPlayerX;
		let y = GetPlayerY;
		
		// if(lx != x || ly != y){
			// ang = AngleToLocation(lx, ly, x, y);
			// xm = cos(ang);
			// ym = sin(ang);
			// lx = x; 
			// ly = y;
		// }
		
			ang = AngleToLocation(GetMouseX-GetStgFrameLeft, GetMouseY-GetStgFrameTop, x, y);
			xm = cos(ang);
			ym = sin(ang);
			xml = cos(ang-angdev);
			yml = sin(ang-angdev);
	
			xmr = cos(ang+angdev);
			ymr = sin(ang+angdev);
		
		ascent(i in 0..4){
			// let a = CreateObjShotB2(EnemyX,EnemyY-30,3*cos(dir),-9-(0.5*sin(dir)),0,0.15,0,12,163,10);
			// let a = CreateObjShotB2(x, y, -9*xm, -9*ym, 0.15*xm, 0.15*ym, 12*xm, 12*ym, 163, 10);
			let a = CreateObjShotB2(x, y, -9*GetRandomAngDev(xm, xml, xmr), -9*GetRandomAngDev(ym, yml, ymr), 0.15*xm, 0.15*ym, 12*xm, 12*ym, 163, 10);
			ObjRender_SetBlendType(a,BLEND_ADD_ARGB);
			if(!Hold(6)){break;}
		}
		if(!Hold(6)){break;}
		yield;
	}
	
	function GetRandomAngDev(orig, ld, rd){
		return rand(ld, rd);
		// return orig;
	}
}





