

#include"./../../BackgroundFunctions.txt"

let source = GetCurrentScriptDirectory;

let Screen = source ~ "screencover.png";
let bg0 = source ~ "grid.png";
let bg1 = source ~ "world01.png";
let bg2 = source ~ "world02.png";
let bg2b = source ~ "world02b.png";
let bg3 = source ~ "world03.png";
let bg4 = source ~ "world04.png";


@Initialize{
	SetAutoDeleteObject(true);
	SetCommonData("stgspeed", 3);
	Stage1Bg;
}
@MainLoop{
	let a = GetEnemyBossSceneObjectID;
	stgspeed = GetCommonData("stgspeed", 3); // this should only be changed in the boss's final sc
	//a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL) | GetKeyState(KEY_H)!=KEY_FREE
	if(a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL)){SpellActive = true;}else{SpellActive = false;}
	if(stgspeed > 3){SpellActive = false;}
	if(stgspeed == 0){RunningCondition = false;}else{RunningCondition = true;}
	yield;
}

task Stage1Bg{
	let ypos = 0;
	let xpos = 0;
	let wpos = 0;
	let cam = 0;
	
	SetCameraFocusX(0);
	SetCameraFocusY(0);
	SetCameraFocusZ(32);
	SetCameraRadius(300);
	SetCameraElevationAngle(285);
	SetCameraAzimuthAngle(90);
	
	SetCameraRoll(0);
	SetCameraYaw(0);
	SetCameraPitch(0);
	
	let ScreenCover = CreateSimple2DImageA1(0.28, Screen);
	ObjRender_SetPosition(ScreenCover, GetStgFrameLeft, GetStgFrameTop, 0);
	ObjSprite2D_SetDestRect(ScreenCover, 0, 0, GetStgFrameWidth, GetStgFrameHeight);
	ObjRender_SetColor(ScreenCover, 255, 32, 128);
	ObjRender_SetAlpha(ScreenCover, 96);
	ObjRender_SetPermitCamera(ScreenCover, false);

	// CreateMagicCircle(100, -80, -400, bg2, 512, 0.11);
	// CreateMagicCircle(200, -80, -400, bg2, 512, -0.07);
	// CreateMagicCircle(300, -80, -400, bg2, 512, -0.03);
	CreateSunBrushB1;
	CreateCloudBrushY1;
	stgspeed = 6;
	
	
	while(RunningCondition){
		yield;
	}
	Obj_Delete(ScreenCover);
	yield;
	CloseScript(GetOwnScriptID);
}

task CreateSunBrushB1{
	let SunRender = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriority(SunRender, 0.24);
	ObjPrim_SetTexture(SunRender, bg2b);
	ObjSpriteList2D_SetSourceRect(SunRender, 0, 0, 512, 512);
	ObjSpriteList2D_SetDestRect(SunRender, -256, -256, 256, 256);
	
	let LargeSunRender = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	Obj_SetRenderPriority(LargeSunRender, 0.23);
	ObjPrim_SetTexture(LargeSunRender, bg2);
	ObjSpriteList2D_SetSourceRect(LargeSunRender, 0, 0, 512, 512);
	ObjSpriteList2D_SetDestRect(LargeSunRender, -256, -256, 256, 256);
	ObjRender_SetPosition(LargeSunRender, GetStgFrameWidth/2, GetStgFrameHeight/3, 0);
	ObjRender_SetScaleXYZ(LargeSunRender, 0.8, 0.8, 0);
	
	let tx = GetStgFrameWidth/2;
	let ty = GetStgFrameHeight/2-48;
	
	let widthx = GetStgFrameWidth/2;
	
	let lent = 70;
	let ldiv = 3;
	let ltimer = 0;
	
	DoStuff;
	
	CreateLargeSun(0.11);
	CreateLargeSun(-0.07);
	CreateLargeSun(-0.03);
	
	while(RunningCondition){
		loop(ldiv){yield;}
		CreateInvAura(25, 1.3, rand(180, 255), rand(127, 255), rand(127, 255));
		CreateInvAura(60, 1.1, rand(180, 255), rand(127, 255), rand(127, 255));
		CreateInvAura(100, 0.9, rand(180, 255), rand(127, 255), rand(127, 255));
	}
	loop(lent){yield;}
	Obj_Delete(SunRender);
	Obj_Delete(LargeSunRender);
	
	task CreateInvAura(dur, mscl, r, g, b){
		let xm = 1-2*round(rand(0, 1));
		
		let dist = GetStgFrameHeight;
		let ang = 270+rand(-135, 135);
		let mx = dist*cos(ang);
		let my = dist*sin(ang);
		
		let lx = tx+mx*0.1;
		let ly = ty+my*0.1;
		
		
		let rscl = rand(0.04, 0.05)*mscl;
		let alpha = 255;
		
		descent(i in 0..dur){
			let mod = i/dur;
			let rmod = mod;
			let nscl = rscl*mod;
			ObjRender_SetPosition(SunRender, lx+mx*rmod, ly+my*rmod, 0);
			ObjRender_SetScaleXYZ(SunRender, nscl, nscl, 0);
			ObjRender_SetColor(SunRender, r, g, b);
			ObjSpriteList2D_AddVertex(SunRender);
			yield;
		}
	}
	
	task CreateLargeSun(angmov){
		angmov *= (stgspeed/3*4);
		let sangle = 220;
		while(!Obj_IsDeleted(SunRender)){		
			sangle += angmov;
			let cm = 96*max(0, sin(absolute(sangle*6)+90));
			ObjRender_SetAngleZ(LargeSunRender, sangle);
			ObjRender_SetColor(LargeSunRender, 128+cm, 64+cm, 64+cm);
			
			ObjSpriteList2D_AddVertex(LargeSunRender);
			
			yield;
		}
	}
	
	task DoStuff{
		while(!Obj_IsDeleted(SunRender)){
			ObjSpriteList2D_ClearVertexCount(SunRender);
			ObjSpriteList2D_ClearVertexCount(LargeSunRender);
			yield;
		}
	}
	
	
	
}

task CreateCloudBrushY1{
	let VertCount = 0;
	let VertDel = 0;
	let CloudRender = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	ObjRender_SetBlendType(CloudRender, BLEND_ALPHA);
	Obj_SetRenderPriority(CloudRender, 0.24);
	ObjPrim_SetTexture(CloudRender, bg4);
	ObjSpriteList2D_SetSourceRect(CloudRender, 0, 0, 256, 256);
	ObjSpriteList2D_SetDestRect(CloudRender, -128, -128, 128, 128);
	ObjRender_SetColor(CloudRender, 172, 0, 80);

	DoStuff;
	
	while(RunningCondition){
		ascent(i in 0..2){
			loop(8){if(!RunningCondition){return;}yield;Obj_SetVisible(CloudRender, !SpellActive);}
			let lmod = (1-2*i);
			CreateCloudA1(200, 2, GetStgFrameWidth/2-64*lmod, GetStgFrameHeight-144, rand(1.3, 2)*lmod, rand(0.65, 0.8), rand(-1, 1));
		}
	}
	
	
	task CreateCloudA1(time, amax, x, y, xv, yv, amod){
		let a = 0;
		let rang = rand(0,360);
		let mod2 = rand(0.7, 0.97);
		descent(i in 0..time){
			let mod = i/time;
			let smod = sin(mod*180);
			a = min(a+amax, 255);
			x+=xv;
			y+=yv;
			rang += amod;
			ObjRender_SetPosition(CloudRender, x, y, 0);
			ObjRender_SetScaleXYZ(CloudRender, mod2, mod2, 1);
			ObjRender_SetAngleZ(CloudRender, rang);
			ObjRender_SetAlpha(CloudRender, a*smod);
			ObjSpriteList2D_AddVertex(CloudRender);
			yield;
		}
	}
	
	task DoStuff{
		while(!Obj_IsDeleted(CloudRender)){
			ObjSpriteList2D_ClearVertexCount(CloudRender);
			yield;
		}
	}
	
	task CreateCloudB1(time, amax, x, y, z, xv, yv, amod){
		//use primitive 3d sprite triangle list
		VertCount++;
		ObjPrim_SetVertexCount(CloudRender, VertCount*6);
		let localIndex = VertCount;
		let locI = localIndex*6;
		
		let points = [
			[0, 0],
			[0, 1],
			[1, 1],
			[0, 0],
			[1, 0],
			[1, 1]
		];
		
		ascent(i in 0..6){
			let lpoint = points[i];
			ObjPrim_SetVertexPosition(CloudRender, locI+i, x+256*(1-2*lpoint[0]), y+256*(1-2*lpoint[1]), z);
			ObjPrim_SetVertexUV(CloudRender, locI+i, lpoint[0], lpoint[1]);
		}
		
		let a = 0;
		let rang = rand(0,360);
		descent(i in 0..time){
			if(VertDel!=0){
				localIndex -= VertDel;
				locI = localIndex*6;
			}
			let mod = i/time;
			let scm = mod^0.25;
			a = min(a+0.75, amax);
			x+=xv;
			y+=yv;
			z+=(xv+yv)*0.25;
			rang += amod;
			ascent(i in 0..6){
				let lpoint = points[i];
				ObjPrim_SetVertexPosition(CloudRender, locI+i, y+64*(1-2*lpoint[0]), z, x+64*(1-2*lpoint[1]));
				ObjPrim_SetVertexUV(CloudRender, locI+i, lpoint[0], lpoint[1]);
				ObjPrim_SetVertexAlpha(CloudRender, locI+i, a*mod^0.5);
			}
			yield;
		}
		MarkForDeletion;
	}
	task MarkForDeletion{
		VertCount--;
		VertDel = 1;
		yield;
		VertDel = 0;
		ObjPrim_SetVertexCount(CloudRender, VertCount*6);
	}
}

