
let source = GetCurrentScriptDirectory;

let Screen = source ~ "screencover.png";
let bg0 = source ~ "grid.png";
let bg1 = source ~ "world01.png";
let bg2 = source ~ "world02.png";
let bg2b = source ~ "world02b.png";
let bg3 = source ~ "world03.png";
let bg4 = source ~ "world04.png";

let stgspeed = 3;
let RunningCondition = true;
let SpellActive = false;
let quality = GetCommonData("quality", 2);

@Initialize{
	SetAutoDeleteObject(true);
	SetCommonData("stgspeed", 3);
	Stage1Bg;
}
@MainLoop{
	let a = GetEnemyBossSceneObjectID;
	stgspeed = GetCommonData("stgspeed", 3); // this should only be changed in the boss's final sc
	//a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL) | GetKeyState(KEY_H)!=KEY_FREE
	if(a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL)){SpellActive = true;}else{SpellActive = false;}
	if(stgspeed > 3){SpellActive = false;}
	if(stgspeed == 0){RunningCondition = false;}else{RunningCondition = true;}
	yield;
}

task Stage1Bg{
	let ypos = 0;
	let xpos = 0;
	let wpos = 0;
	let cam = 0;
	
	SetCameraFocusX(0);
	SetCameraFocusY(0);
	SetCameraFocusZ(32);
	SetCameraRadius(300);
	SetCameraElevationAngle(285);
	SetCameraAzimuthAngle(90);
	
	let StageBGSky = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageBGSky, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBGSky, 255);
	ObjPrim_SetTexture(StageBGSky, NULL);
	ObjSprite3D_SetSourceRect(StageBGSky, 0, 0, 0, 0);
	ObjSprite3D_SetDestRect(StageBGSky, -640, 0, 640, 1024);
	ObjRender_SetColor(StageBGSky, 16, 0, 6);
	ObjRender_SetFogEnable(StageBGSky, false);
	ObjRender_SetPosition(StageBGSky, 0, 1675, -500);
	ObjRender_SetAngleXYZ(StageBGSky, 90, 0, 0);
	Obj_SetRenderPriority(StageBGSky, 0.21);
	ObjRender_SetZWrite(StageBGSky, true);
	ObjRender_SetZTest(StageBGSky, true);
	
	let ScreenCover = CreateSimple2DImageA1(0.28, Screen);
	ObjRender_SetPosition(ScreenCover, GetStgFrameLeft, GetStgFrameTop, 0);
	ObjSprite2D_SetDestRect(ScreenCover, 0, 0, GetStgFrameWidth, GetStgFrameHeight);
	ObjRender_SetColor(ScreenCover, min(176, 48*stgspeed), 0, min(128, 16*stgspeed));
	ObjRender_SetAlpha(ScreenCover, min(255, 48*stgspeed));
	ObjRender_SetPermitCamera(ScreenCover, false);
	
	SetFogEnable(false);
	SetFogParam(2000, 3000, 64, 64, 64);
	
	let vcount = 32;
	let cave = CreateCircleCaveA1(bg1, vcount, 256, 1650);
	CreateSunClusterA1(200, 900, -200, 96, 204, 0, 190, 0.85, 3);
	CreateSunClusterA1(-125, 400, 100, 0, 204, 16, 64, 1.15, 3);
	CreateMagicCircle(0, 0, 0, bg3, 256, 0.1);
	CreateMagicCircle(0, 0, 0, bg3, 256, -0.1);
	// CreateSunBrushB1;
	CreateCloudBrushY1;
	CreateSunBrushA1(1);
	
	// CameraFlight;
	// RunningCondition = false;
	while(RunningCondition){
		RenderBG;
		yield;
	}
	Obj_Delete(cave);
	Obj_Delete(StageBGSky);
	
	// yield;
	RunningCondition = true;
	// yield;
	yield;
	// ObjRender_SetPosition(ScreenCover, 0, 0, 0);
	ObjSprite2D_SetDestRect(ScreenCover, 0, 0, GetStgFrameWidth, GetStgFrameHeight);
	// ObjRender_SetColor(ScreenCover, 0, min(176, 48*stgspeed), min(128, 16*stgspeed));
	CreateMagicCircle(100, -80, -400, bg2, 512, 0.11);
	CreateMagicCircle(200, -80, -400, bg2, 512, -0.07);
	CreateMagicCircle(300, -80, -400, bg2, 512, -0.03);
	CreateSunBrushB1;
	stgspeed = 6;
	CreateCloudBrushY1;
	stgspeed = 6;
	
	SetCameraRoll(0);
	SetCameraYaw(0);
	SetCameraPitch(0);
	ObjRender_SetColor(ScreenCover, 255, 32, 128);
	ObjRender_SetAlpha(ScreenCover, 96);
	while(RunningCondition){
		// RenderBG;
		yield;
	}
	Obj_Delete(ScreenCover);
	yield;
	CloseScript(GetOwnScriptID);
	
	sub RenderBG{
		cam+=stgspeed/3;
		xpos += stgspeed;
		Obj_SetVisible(cave, !SpellActive&&stgspeed < 9);
		Obj_SetVisible(StageBGSky, !SpellActive&&stgspeed < 9);
		Obj_SetVisible(ScreenCover, !SpellActive);
		ObjRender_SetColor(ScreenCover, min(176, 32*stgspeed), 0, min(128, 16*stgspeed));
		ObjRender_SetAlpha(ScreenCover, min(255, 96+12*stgspeed));
		ascent(i in 0..vcount/2){
			let ivert = i*2;
			ObjPrim_SetVertexUVT(cave, ivert+0, xpos, 256*4/vcount*i);
			ObjPrim_SetVertexUVT(cave, ivert+1, 192+xpos, 256*4/vcount*i);
		}
		SetCameraRoll(sin(cam*0.1)*6);
		SetCameraYaw(sin(cam*0.5)*6);
		SetCameraPitch(sin(cam*0.1)*2);
	}
}


function CreateCircleCaveA1(texture, vcount, width, length){
	let obj = ObjPrim_Create(OBJ_PRIMITIVE_3D);
	ObjPrim_SetPrimitiveType(obj, PRIMITIVE_TRIANGLESTRIP);
	ObjRender_SetAngleXYZ(obj, 0, -90, 0);
	
	ObjPrim_SetVertexCount(obj, vcount);
	ObjPrim_SetTexture(obj, texture);
	Obj_SetRenderPriority(obj, 0.23);
	let wcount = vcount/2;
	ascent(i in 0..vcount/2){
		let ivert = i*2;
		let angle = 360/(vcount/2-1)*i;
		ObjPrim_SetVertexUVT(obj, ivert+0, 96, 512*4/vcount*i);
		ObjPrim_SetVertexUVT(obj, ivert+1, 512+96, 512*4/vcount*i);
		ObjPrim_SetVertexPosition(obj, ivert+0, width*cos(angle), 0, width*sin(angle));
		ObjPrim_SetVertexPosition(obj, ivert+1, width*cos(angle), length, width*sin(angle));
	}
	return obj;
}

task CreateMagicCircle(x, y, z, img, srect, dir){
	let sangle = x;
	let obj = Create3DBrush(255, srect, 0, img, 0.23);
	ObjSprite3D_SetDestRect(obj, -srect/2, -srect/2, srect/2, srect/2);
	ObjRender_SetPosition(obj, 0, 1650+z, y);
	ObjRender_SetScaleXYZ(obj, 2, 2, 1);
	ObjRender_SetColor(obj, 128, 128, 128);
	while(RunningCondition){
		Obj_SetVisible(obj, !SpellActive);
		sangle += dir*(stgspeed/3);
		let cm = 96*max(0, sin(absolute(sangle*6)+90));
		ObjRender_SetAngleXYZ(obj, 90, 0, sangle);
		ObjRender_SetColor(obj, 128+cm, 64+cm, 64+cm);
		yield;
	}
	Obj_Delete(obj);
}

task CreateSunClusterA1(x, by, my, z, r, g, b, s, l){
	loop(l){CreateSun(0, s, 0, 0, rand(0.25, 0.85));}
	loop(l){CreateSun(0, s, 0, 0, rand(-0.25, -0.85));}
	
	loop(6){
		//dist, scale, langle, dir, spd
		let rp = [rand(-256, 256), rand(0.1, 0.2)*s, rand(0,360), round(rand(0, 1)), rand(0.05, 0.5)];
		while(absolute(rp[0]) < 96*s){rp[0] = rand(-256, 256);}
		if(rp[3] == 0){rp[3] = -1;}
		rp[4] = rp[4] * rp[3];
		CreateSun(rp[0], rp[1], rp[2], rp[4], rand(0.25, 0.85)*2);
		CreateSun(rp[0], rp[1], rp[2], rp[4], -rand(0.25, 0.85)*2);
	}

	task CreateSun(w, ls, langle, spd, mod){
		let sangle = rand(0,360);
		let movmod = 0;
		let obj = Create3DBrush(255, 512, 0, bg2, 0.25);
		ObjSprite3D_SetDestRect(obj, -256, -256, 256, 256);
		ObjRender_SetAngleXYZ(obj, 0, 0, sangle);
		ObjRender_SetScaleXYZ(obj, ls, ls, 1);
		let cm = 1-min(absolute(w), 0.25); //on the big suns, w is 0
		ObjRender_SetColor(obj, r*cm, g*cm, b*cm);
		ObjSprite3D_SetBillboard(obj, true);
		
		while(RunningCondition){
			Obj_SetVisible(obj, !SpellActive);
			sangle += mod;
			langle += spd*(stgspeed/3);
			movmod += stgspeed*0.02;
			ObjRender_SetPosition(obj, x*cos(movmod)+w*cos(langle), by+my*sin(movmod/2)+w*sin(langle)*0.5, my*sin(movmod)+z+w*sin(langle));
			ObjRender_SetAngleXYZ(obj, 0, 0, sangle);
			yield;
		}
		Obj_Delete(obj);
	}
}

task CreateSunBrushA1(l){
	loop{
		let rp = [rand(-256, 256), rand(-128, 128), rand(-256, 256), rand(0.05, 0.25)];
		while(absolute(rp[0]) < 96){rp[0] = rand(-256, 256);}
		while(absolute(rp[2]) < 96){rp[2] = rand(-256, 256);}
		
		let rc = [128+128*(1-rand(0,1)^2), 32*(rand(0,1)^2), 255*(1-rand(0,1)^2)];
		loop(l){
			CreateSun(rp[0], rp[1], rp[2], rc[0], rc[1], rc[2], rp[3], rand(0.25, 0.85));
			CreateSun(rp[0], rp[1], rp[2], rc[0], rc[1], rc[2], rp[3], -rand(0.25, 0.85));
		}
		loop(10){yield;}
	}
	
	task CreateSun(x, y, z, r, g, b, s, mod){
		let sangle = rand(0,360);
		let alpha = 0;
		let obj = Create3DBrush(255, 512, 0, bg2, 0.25);
		ObjSprite3D_SetDestRect(obj, -256, -256, 256, 256);
		ObjRender_SetPosition(obj, x, y, z);
		ObjRender_SetAngleXYZ(obj, 0, 0, sangle);
		ObjRender_SetScaleXYZ(obj, s, s, 1);
		ObjRender_SetColor(obj, r, g, b);
		ObjRender_SetAlpha(obj, alpha);
		ObjSprite3D_SetBillboard(obj, true);
		
		while(ObjRender_GetY(obj) < 1400 && s > 0){
			alpha = min(alpha + 2, 255);
			s = max(s-0.001, 0);
			ObjRender_SetScaleXYZ(obj, s, s, 1);
			ObjRender_SetAlpha(obj, alpha);
			RenderMovement;
			yield;
		}
		if(s<=0){Obj_Delete(obj); return;}
		ascent(i in 0..120){
			let sc = s-s/120*i;
			ObjRender_SetAlpha(obj, 255-255/120*i);
			ObjRender_SetScaleXYZ(obj, sc, sc, 1);
			RenderMovement;
			yield;
		}
		Obj_Delete(obj);
		
		sub RenderMovement{
			Obj_SetVisible(obj, !SpellActive);
			sangle += mod;
			ObjRender_SetAngleXYZ(obj, 0, 0, sangle);
			ObjRender_SetY(obj, ObjRender_GetY(obj)+stgspeed*2.5);
		}
	}
}

task CreateSunBrushB1{
	let SunRender = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	ObjRender_SetBlendType(SunRender, BLEND_ALPHA);
	Obj_SetRenderPriority(SunRender, 0.24);
	ObjPrim_SetTexture(SunRender, bg2b);
	ObjSpriteList2D_SetSourceRect(SunRender, 0, 0, 512, 512);
	ObjSpriteList2D_SetDestRect(SunRender, -256, -256, 256, 256);
	
	let tx = GetStgFrameWidth/2;
	let ty = GetStgFrameHeight/2-48;
	
	let widthx = GetStgFrameWidth/2;
	
	let lent = 70;
	let ldiv = 2;
	let ltimer = 0;
	
	DoStuff;
	
	while(RunningCondition){
		loop(ldiv){yield;}
		CreateInvAura(30, 1.3, rand(180, 255), rand(127, 255), rand(127, 255));
		CreateInvAura(65, 1.1, rand(180, 255), rand(127, 255), rand(127, 255));
		CreateInvAura(105, 0.9, rand(180, 255), rand(127, 255), rand(127, 255));
	}
	loop(lent){yield;}
	Obj_Delete(SunRender);
	
	task CreateInvAura(dur, mscl, r, g, b){
		
		let xm = 1-2*round(rand(0, 1));
		
		let dist = GetStgFrameHeight;
		let ang = 270+rand(-145, 145);
		let mx = cos(ang);
		let my = sin(ang);
		
		let lx = tx+dist*0.1*mx;
		let ly = ty+dist*0.1*my;
		
		
		let rscl = rand(0.04, 0.05)*mscl;
		let alpha = 255;
		
		descent(i in 0..dur){
			let mod = i/dur;
			let rmod = mod;
			let nscl = rscl*mod;
			let col = 127*cos(mod*90);
			ObjRender_SetPosition(SunRender, lx+mx*dist*rmod, ly+my*dist*rmod, 0);
			ObjRender_SetScaleXYZ(SunRender, nscl, nscl, 0);
			ObjRender_SetColor(SunRender, r, g, b);
			ObjSpriteList2D_AddVertex(SunRender);
			yield;
		}
	}
	
	task DoStuff{
		while(!Obj_IsDeleted(SunRender)){
			ObjSpriteList2D_ClearVertexCount(SunRender);
			yield;
		}
	}
	
}


task CreateCloudBrushY1{

	let VertCount = 0;
	let VertDel = 0;
	let CloudRender = ObjPrim_Create(OBJ_SPRITE_LIST_2D);
	ObjRender_SetBlendType(CloudRender, BLEND_ALPHA);
	Obj_SetRenderPriority(CloudRender, 0.24);
	ObjPrim_SetTexture(CloudRender, bg4);
	ObjSpriteList2D_SetSourceRect(CloudRender, 0, 0, 256, 256);
	ObjSpriteList2D_SetDestRect(CloudRender, -128, -128, 128, 128);
	ObjRender_SetColor(CloudRender, 172, 0, 80);

	DoStuff;
	while(stgspeed == 3){
		loop(8){if(!RunningCondition){return;}yield;Obj_SetVisible(CloudRender, !SpellActive);}
		// CreateCloudA1(200, 255, rand(-75, 75), rand(128, 1400)*(rand(0,1)^2), rand(-100, 32), rand(-0.75, 0.75), rand(-0.75, 0.15), rand(-1.5, 1.5));
		CreateCloudA1(200, 0.75, rand(-12, GetStgFrameWidth+12), GetStgFrameHeight+rand(-128, 32), rand(-0.75, 0.75), rand(-0.45, 0.1), rand(-1.1, 1.1));
	}
	
	while(RunningCondition){
		ascent(i in 0..2){
			loop(8){if(!RunningCondition){return;}yield;Obj_SetVisible(CloudRender, !SpellActive);}
			let lmod = (1-2*i);
			CreateCloudA1(200, 2, GetStgFrameWidth/2-48*lmod, GetStgFrameHeight-144, rand(1.5, 2.2)*lmod, rand(0.65, 0.8), rand(-1, 1));
		}
	}
	
	
	task CreateCloudA1(time, amax, x, y, xv, yv, amod){
		let a = 0;
		let rang = rand(0,360);
		let mod2 = rand(0.8, 1.15);
		descent(i in 0..time){
			let mod = i/time;
			let smod = sin(mod*180);
			let scm = mod^0.15;
			a = min(a+amax, 255);
			x+=xv;
			y+=yv;
			rang += amod;
			ObjRender_SetPosition(CloudRender, x, y, 0);
			ObjRender_SetScaleXYZ(CloudRender, scm*mod2, scm*mod2, 1);
			ObjRender_SetAngleZ(CloudRender, rang);
			ObjRender_SetAlpha(CloudRender, a*smod);
			ObjSpriteList2D_AddVertex(CloudRender);
			yield;
		}
	}
	
	task DoStuff{
		while(!Obj_IsDeleted(CloudRender)){
			ObjSpriteList2D_ClearVertexCount(CloudRender);
			yield;
		}
	}
	
	task CreateCloudB1(time, amax, x, y, z, xv, yv, amod){
		//use primitive 3d sprite triangle list
		VertCount++;
		ObjPrim_SetVertexCount(CloudRender, VertCount*6);
		let localIndex = VertCount;
		let locI = localIndex*6;
		
		let points = [
			[0, 0],
			[0, 1],
			[1, 1],
			[0, 0],
			[1, 0],
			[1, 1]
		];
		
		ascent(i in 0..6){
			let lpoint = points[i];
			ObjPrim_SetVertexPosition(CloudRender, locI+i, x+256*(1-2*lpoint[0]), y+256*(1-2*lpoint[1]), z);
			ObjPrim_SetVertexUV(CloudRender, locI+i, lpoint[0], lpoint[1]);
		}
		
		let a = 0;
		let rang = rand(0,360);
		descent(i in 0..time){
			if(VertDel!=0){
				localIndex -= VertDel;
				locI = localIndex*6;
			}
			let mod = i/time;
			let scm = mod^0.25;
			a = min(a+0.75, amax);
			x+=xv;
			y+=yv;
			z+=(xv+yv)*0.25;
			rang += amod;
			ascent(i in 0..6){
				let lpoint = points[i];
				ObjPrim_SetVertexPosition(CloudRender, locI+i, y+64*(1-2*lpoint[0]), z, x+64*(1-2*lpoint[1]));
				ObjPrim_SetVertexUV(CloudRender, locI+i, lpoint[0], lpoint[1]);
				ObjPrim_SetVertexAlpha(CloudRender, locI+i, a*mod^0.5);
			}
			yield;
		}
		MarkForDeletion;
	}
	task MarkForDeletion{
		VertCount--;
		VertDel = 1;
		yield;
		VertDel = 0;
		ObjPrim_SetVertexCount(CloudRender, VertCount*6);
	}
}


function Create3DBrush(alpha, srcrect, offset, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0+offset, 0+offset, srcrect+offset, srcrect+offset);
	ObjSprite3D_SetDestRect(StageProp, 0, -srcrect/2, srcrect, srcrect/2); // Centered middle origin maybe
	//ObjRender_SetZWrite(StageProp, true);
	//ObjRender_SetZTest(StageProp, true);
	return StageProp;
}
function Create3DProperties(alpha, srcrect, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0, 0, srcrect, srcrect);
	ObjSprite3D_SetDestRect(StageProp, -srcrect, -srcrect, srcrect, srcrect);
	ObjRender_SetZWrite(StageProp, true);
	ObjRender_SetZTest(StageProp, true);
	return StageProp;
}

function Create3DEnvironment(image, srcrect, pri){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetY(StageProp, -64);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, pri);
	ObjSprite3D_SetSourceRect(StageProp, 0, 0, srcrect*4, srcrect*4);
	ObjSprite3D_SetDestRect(StageProp, -srcrect*2, 0, srcrect*2, srcrect*4);
	ObjRender_SetZWrite(StageProp, true);
	ObjRender_SetZTest(StageProp, true);
	return StageProp;
}

task BackgroundShakeA1(intensity, intdec){
	while(intensity>0){
		Set2DCameraFocusX(GetStgFrameWidth/2 + rand(-intensity, intensity));
		Set2DCameraFocusY(GetStgFrameHeight/2 + rand(-intensity, intensity));
		SetCameraFocusX(rand(-intensity, intensity));
		SetCameraFocusZ(100+rand(-intensity, intensity));
		intensity-=intdec;
		yield;
	}
	SetCameraFocusX(0);
	SetCameraFocusZ(100);
	Reset2DCamera;
	yield;
}

task CameraFlight{
	// Static Version
	let pos = [0,0,100];
	let ang = [90,295,300];
	let cammod = 1.25;
	loop{
		if(GetKeyState(KEY_J)==KEY_HOLD){pos[0]=pos[0]+5*cammod;}
		if(GetKeyState(KEY_L)==KEY_HOLD){pos[0]=pos[0]-5*cammod;}
		if(GetKeyState(KEY_I)==KEY_HOLD){pos[1]=pos[1]+5*cammod;}
		if(GetKeyState(KEY_K)==KEY_HOLD){pos[1]=pos[1]-5*cammod;}
		if(GetKeyState(KEY_U)==KEY_HOLD){pos[2]=pos[2]-5*cammod;}
		if(GetKeyState(KEY_O)==KEY_HOLD){pos[2]=pos[2]+5*cammod;}
		
		
		if(GetKeyState(KEY_Q)==KEY_HOLD){ang[0]=ang[0]+2*cammod;}
		if(GetKeyState(KEY_E)==KEY_HOLD){ang[0]=ang[0]-2*cammod;}
		if(GetKeyState(KEY_W)==KEY_HOLD){ang[1]=ang[1]+2*cammod;}
		if(GetKeyState(KEY_S)==KEY_HOLD){ang[1]=ang[1]-2*cammod;}
		if(GetKeyState(KEY_A)==KEY_HOLD){ang[2]=ang[2]+2*cammod;}
		if(GetKeyState(KEY_D)==KEY_HOLD){ang[2]=ang[2]-2*cammod;}
		
		SetCameraFocusX(pos[0]);
		SetCameraFocusY(pos[1]);
		SetCameraFocusZ(pos[2]);
		SetCameraAzimuthAngle(ang[0]);	
		SetCameraElevationAngle(ang[1]);
		SetCameraRadius(ang[2]);
		yield;
	}
}

function GetDistance(x1,y1,x2,y2){
	return(((x2-x1)^2+(y2-y1)^2)^(1/2))
}

function AngleToLocation(x1, y1, x2, y2){
	return atan2(y2 - y1, x2 - x1);
}

function CreateSimple2DImageA1(pri, image){
	let obj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(obj, BLEND_ALPHA);
	Obj_SetRenderPriority(obj, pri);
	ObjPrim_SetTexture(obj, image);
	let test = [GetTextureWidth(image), GetTextureHeight(image)];
	ObjSprite2D_SetSourceRect(obj, 0, 0, test[0]-1, test[1]-1);
	ObjSprite2D_SetDestRect(obj, -(test[0]/2+0.5), -(test[1]/2), (test[0]/2), (test[1]/2));
	return obj;
}


task PlaySoundA1(name){
	let ID = -1;
	let GlobalSounds = GetCommonData("GlobalSoundData", [-1]);
	let GlobalSndStr = GetCommonData("GlobalSndStrData", [-1]);
	ascent(i in 0..length(GlobalSndStr)){
		if(GlobalSndStr[i]==name){ID = i; break;}
	}
	if(ID==-1){RaiseError("Error when attempting to play audio: "~name);}
	ObjSound_Play(GlobalSounds[ID]);
}

